"""Add tables for register data

Revision ID: 6de51673a0ef
Revises: f4adeca56f06
Create Date: 2022-01-07 21:41:16.117138

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = "6de51673a0ef"
down_revision = "f4adeca56f06"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "register",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("name", sa.String(), nullable=False),
        sa.PrimaryKeyConstraint("id", name=op.f("pk_register")),
    )
    op.create_index(op.f("ix_register_name"), "register", ["name"], unique=True)
    op.create_table(
        "component_record",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("config_id", sa.Integer(), nullable=False),
        sa.Column("component", sa.String(), nullable=False),
        sa.ForeignKeyConstraint(
            ["config_id"],
            ["configuration.id"],
            name=op.f("fk_component_record_config_id_configuration"),
        ),
        sa.PrimaryKeyConstraint("id", name=op.f("pk_component_record")),
        sa.UniqueConstraint("config_id", "component", name=op.f("uq_component_record_config_id")),
    )
    op.create_table(
        "record",
        sa.Column("id", sa.BigInteger(), nullable=False),
        sa.Column("parent_id", sa.Integer(), nullable=False),
        sa.Column("register_id", sa.Integer(), nullable=False),
        sa.Column("value", sa.BigInteger(), nullable=False),
        sa.ForeignKeyConstraint(
            ["parent_id"],
            ["component_record.id"],
            name=op.f("fk_record_parent_id_component_record"),
        ),
        sa.ForeignKeyConstraint(
            ["register_id"], ["register.id"], name=op.f("fk_record_register_id_register")
        ),
        sa.PrimaryKeyConstraint("id", name=op.f("pk_record")),
        sa.UniqueConstraint("parent_id", "register_id", name=op.f("uq_record_parent_id")),
    )
    op.drop_constraint("key_name_key", "key", type_="unique")
    op.create_unique_constraint(op.f("uq_key_name"), "key", ["name"])
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint(op.f("uq_key_name"), "key", type_="unique")
    op.create_unique_constraint("key_name_key", "key", ["name"])
    op.drop_table("record")
    op.drop_table("component_record")
    op.drop_index(op.f("ix_register_name"), table_name="register")
    op.drop_table("register")
    # ### end Alembic commands ###
